#include <stdio.h>
#include <stdlib.h>

void stampa_matrice_din(int** mat, int m, int n) {
    int i, j;
    for (i = 0; i < m; i++) {
        for (j = 0; j < n; j++) {
            printf("%d ", mat[i][j]);
        }
        printf("\n");
    }
}

int** init_rnd(int m, int n) {
    srand(time(0));
    int i, j;
    int** A = malloc(m*sizeof(int*));
    for (i = 0; i < m; i++) {
        A[i] = malloc(n*sizeof(int));
    }
    for (i = 0; i < m; i++) {
        for (j = 0; j < n; j++) {
            A[i][j] = rand() % 10;
        }
    }
    return A;
}

int** maxpool(int** A, int m, int n, int k) {
    int i, j, i1, j1, max;

    int** B = malloc((m/k)*sizeof(int*));
    for (i = 0; i < m/k; i++) {
        B[i] = malloc((n/k)*sizeof(int));
    }

    for (i = 0; i < m; i += k) {
        for (j = 0; j < n; j += k) {
            max = A[i][j];
            for (i1 = i; i1 < i+k; i1++) {
                for (j1 = j; j1 < j+k; j1++) {
                    if (max < A[i1][j1]) {
                        max = A[i1][j1];
                    }
                }
            }
            B[i/k][j/k] = max;
        }
    }

    return B;
}

int** input_mat(int m, int n) {
    int i, j;
    int** A = malloc(m*sizeof(int*));
    for (i = 0; i < m; i++) {
        A[i] = malloc(n*sizeof(int));
    }
    for (i = 0; i < m; i++) {
        for (j = 0; j < n; j++) {
            scanf("%d", &A[i][j]);
        }
    }
    return A;
}

int pravougaonici(int** A, int m, int n) {
    int i, j, i1, j1, k;
    int max = 0;
    for (i = 0; i < m-1; i++) {
        for (j = 0; j < n-1; j++) {
            for (i1 = i+1; i1 < m; i1++) {
                for (j1 = j+1; j1 < n; j1++) {
                    int ind = 1;
                    for (k = j; k <= j1; k++) {
                        if (A[i][k] == 0) {
                            ind = 0;
                            break;
                        }
                    }
                    for (k = j; k <= j1 && ind; k++) {
                        if (A[i1][k] == 0) {
                            ind = 0;
                            break;
                        }
                    }
                    for (k = i; k <= i1 && ind; k++) {
                        if (A[k][j] == 0) {
                            ind = 0;
                            break;
                        }
                    }
                    for (k = i; k <= i1 && ind; k++) {
                        if (A[k][j1] == 0) {
                            ind = 0;
                            break;
                        }
                    }
                    if (ind) {
                        printf("%d %d %d %d\n", i, j, i1, j1);
                        int p = (i1 - i + 1)*(j1 - j + 1);
                        if (max < p)
                            max = p;
                    }
                }
            }
        }
    }
    return max;
}

int main()
{
    /*int m = 6;
    int n = 6;
    int k = 3;
    int** A = init_rnd(m, n);
    stampa_matrice_din(A, m, n);
    int** B = maxpool(A, m, n, k);
    stampa_matrice_din(B, m/k, n/k);*/

    /*int m = 6;
    int n = 7;
    int** A = input_mat(m, n);
    stampa_matrice_din(A, m, n);
    int max = pravougaonici(A, m, n);
    printf("%d\n", max);*/

    char s1[] = {'p', 'r', 'o', 'g', '\0'};
    printf("%s\n", s1);
    s1[0] = 'a';
    s1[1] = 'b';
    s1[2] = 'c';
    s1[3] = 'd';
    printf("%s\n", s1);

    char s2[] = "programiranje1";
    printf("%s\n", s2);
    s2[13] = '2';
    printf("%s\n", s2);

    char* s3 = "jezik c"; // ne moze da se mijenja
    s3[0] = 'a';

    return 0;
}
